// Faan Tone Liu 02/02/02
// little program to investigate constants and pointers

#include <iostream>
using namespace std;

void test_function(int *, const int *,
                   int * const, const int *const);

int main()
{
    int i1(1), i2(2), i3(3), i4(4);
    int *p1, *p2, *p3, *p4;

    p1 = &i1; p2 = &i2; p3 = &i3; p4 = &i4;
    cout << "Values of pointers and contents before: ";
    cout << p1 << ' ' << p2 << ' ' << p3 << ' ' << p4 << endl;
    cout << *p1 << ' ' << *p2 << ' ' << *p3 << ' ' << *p4 << endl;
    test_function(p1, p2, p3, p4);
    cout << "Values of pointers and contents after: ";
    cout << p1 << ' ' << p2 << ' ' << p3 << ' ' << p4 << endl;
    cout << *p1 << ' ' << *p2 << ' ' << *p3 << ' ' << *p4 << endl;
    // notice that the pointer values haven't changed.  That's because
    // test_function only changed its own copy of the pointer value
    return 0;
}

void test_function(int *ip1, const int *ip2, int * const ip3,
                   const int *const ip4)
{
    int myint;

    *ip1 = 47;
    ip1 = &myint;

//  *ip2 = 47;  //not allowed
    ip2 = &myint;

    *ip3 = 47;
//  ip3 = &myint; //not allowed

//  *ip4 = 47;    //not allowed
//  ip4 = &myint; //not allowed
}
